## rtpengine-mr9.5.1.3.tar.gz

=== Makefile ===
RTPENGINE_ROOT_DIR=.
with_transcoding ?= yes

include lib/lib.Makefile

.PHONY:	all distclean clean coverity

all:
	$(MAKE) -C daemon
ifeq ($(with_transcoding),yes)
	$(MAKE) -C recording-daemon
endif
	$(MAKE) -C iptables-extension

coverity:
	$(MAKE) -C daemon
ifeq ($(with_transcoding),yes)
	$(MAKE) -C recording-daemon
endif

.PHONY: with-kernel

with-kernel: all
	$(MAKE) -C kernel-module

distclean clean:
	$(MAKE) -C daemon clean
	$(MAKE) -C recording-daemon clean
	$(MAKE) -C iptables-extension clean
	$(MAKE) -C kernel-module clean
	$(MAKE) -C t clean

.DEFAULT:
	$(MAKE) -C daemon $@
	$(MAKE) -C recording-daemon $@
	$(MAKE) -C iptables-extension $@
	$(MAKE) -C kernel-module $@

.PHONY: check

check: all
	$(MAKE) -C t

=== daemon/Makefile ===
TARGET=		rtpengine

with_iptables_option ?= yes
with_transcoding ?= yes


CFLAGS?=	-g -Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -Wstrict-prototypes
CFLAGS+=	-pthread -fno-strict-aliasing
CFLAGS+=	-std=c99
CFLAGS+=	$(shell pkg-config --cflags glib-2.0)
CFLAGS+=	$(shell pkg-config --cflags gthread-2.0)
CFLAGS+=	$(shell pkg-config --cflags zlib)
CFLAGS+=	$(shell pkg-config --cflags openssl)
CFLAGS+=	$(shell pkg-config --cflags libevent_pthreads)
CFLAGS+=	$(shell pkg-config --cflags libpcre)
CFLAGS+=	$(shell pkg-config xmlrpc_client --cflags 2> /dev/null || xmlrpc-c-config client --cflags)
CFLAGS+=	$(shell pkg-config xmlrpc --cflags 2> /dev/null)
CFLAGS+=	$(shell pkg-config xmlrpc_util --cflags 2> /dev/null)
CFLAGS+=	$(shell pkg-config --cflags json-glib-1.0)
CFLAGS+=	$(shell pkg-config --cflags libwebsockets)
ifeq ($(with_iptables_option),yes)
CFLAGS+=	$(shell pkg-config --cflags libiptc)
CFLAGS+=	-DWITH_IPTABLES_OPTION
endif
CFLAGS+=	-I. -I../kernel-module/ -I../lib/ -I../include/
CFLAGS+=	-D_GNU_SOURCE
ifeq ($(with_transcoding),yes)
CFLAGS+=	$(shell pkg-config --cflags libavcodec)
CFLAGS+=	$(shell pkg-config --cflags libavformat)
CFLAGS+=	$(shell pkg-config --cflags libavutil)
CFLAGS+=	$(shell pkg-config --cflags libswresample)
CFLAGS+=	$(shell pkg-config --cflags libavfilter)
CFLAGS+=	$(shell pkg-config --cflags spandsp)
CFLAGS+=	-DWITH_TRANSCODING
CFLAGS+=        $(shell mysql_config --cflags)
else
CFLAGS+=	-DWITHOUT_CODECLIB
endif

CFLAGS+=	-DRE_PLUGIN_DIR="\"/usr/lib/rtpengine\""

### compile time options:
#CFLAGS+=	-DSRTCP_KEY_DERIVATION_RFC_COMPLIANCE
#CFLAGS+=	-DTERMINATE_SDP_AT_BLANK_LINE
#CFLAGS+=	-DSTRICT_SDES_KEY_LIFETIME

LDLIBS=		-lm
LDLIBS+=	$(shell pkg-config --libs glib-2.0)
LDLIBS+=	$(shell pkg-config --libs gthread-2.0)
LDLIBS+=	$(shell pkg-config --libs zlib)
LDLIBS+=	$(shell pkg-config --libs libpcre)
LDLIBS+=	$(shell pkg-config --libs libcrypto)
LDLIBS+=	$(shell pkg-config --libs openssl)
LDLIBS+=	$(shell pkg-config --libs libevent_pthreads)
LDLIBS+=	-lpcap
LDLIBS+=	$(shell pkg-config xmlrpc_client --libs 2> /dev/null || xmlrpc-c-config client --libs)
LDLIBS+=	$(shell pkg-config xmlrpc --libs 2> /dev/null)
LDLIBS+=	$(shell pkg-config xmlrpc_util --libs 2> /dev/null)
LDLIBS+=	-lhiredis
LDLIBS+=	$(shell pkg-config --libs json-glib-1.0)
LDLIBS+=	$(shell pkg-config --libs libwebsockets)
ifeq ($(with_iptables_option),yes)
LDLIBS+=	$(shell pkg-config --libs libiptc)
endif
ifeq ($(with_transcoding),yes)
LDLIBS+=	$(shell pkg-config --libs libavcodec)
LDLIBS+=	$(shell pkg-config --libs libavformat)
LDLIBS+=	$(shell pkg-config --libs libavutil)
LDLIBS+=	$(shell pkg-config --libs libswresample)
LDLIBS+=	$(shell pkg-config --libs libavfilter)
LDLIBS+=	$(shell pkg-config --libs spandsp)
LDLIBS+=        $(shell mysql_config --libs)
endif

ifeq ($(with_transcoding),yes)
include ../lib/g729.Makefile
endif

SRCS=		main.c kernel.c poller.c aux.c control_tcp.c call.c control_udp.c redis.c \
		bencode.c cookie_cache.c udp_listener.c control_ng.strhash.c sdp.strhash.c stun.c rtcp.c \
		crypto.c rtp.c call_interfaces.strhash.c dtls.c log.c cli.c graphite.c ice.c \
		media_socket.c homer.c recording.c statistics.c cdr.c ssrc.c iptables.c tcp_listener.c \
		codec.c load.c dtmf.c timerthread.c media_player.c jitter_buffer.c t38.c websocket.c
LIBSRCS=	loglib.c auxlib.c rtplib.c str.c socket.c streambuf.c ssllib.c dtmflib.c
ifeq ($(with_transcoding),yes)
LIBSRCS+=	codeclib.c resample.c
endif
OBJS=		$(SRCS:.c=.o) $(LIBSRCS:.c=.o)

PODS=		rtpengine.pod
MANS=		$(PODS:.pod=.8)

include ../lib/common.Makefile

=== t/Makefile ===
TARGET=		all-tests

with_transcoding ?= yes

CFLAGS?=	-g -Wall -Wextra -Wno-sign-compare -Wno-unused-parameter -Wstrict-prototypes
PRELOAD_CFLAGS := $(CFLAGS)
CFLAGS+=	-pthread -fno-strict-aliasing
CFLAGS+=	-std=c99
CFLAGS+=	$(shell pkg-config --cflags glib-2.0)
CFLAGS+=	$(shell pkg-config --cflags gthread-2.0)
CFLAGS+=	$(shell pkg-config --cflags openssl)
CFLAGS+=	-I. -I../lib/ -I../kernel-module/ -I../include/
CFLAGS+=	-D_GNU_SOURCE
CFLAGS+=	$(shell pkg-config --cflags libpcre)
ifeq ($(with_transcoding),yes)
CFLAGS+=	$(shell pkg-config --cflags libavcodec)
CFLAGS+=	$(shell pkg-config --cflags libavformat)
CFLAGS+=	$(shell pkg-config --cflags libavutil)
CFLAGS+=	$(shell pkg-config --cflags libswresample)
CFLAGS+=	$(shell pkg-config --cflags libavfilter)
CFLAGS+=	$(shell pkg-config --cflags spandsp)
CFLAGS+=	-DWITH_TRANSCODING
CFLAGS+=	$(shell pkg-config --cflags zlib)
CFLAGS+=	$(shell pkg-config --cflags json-glib-1.0)
CFLAGS+=	$(shell pkg-config --cflags libevent_pthreads)
CFLAGS+=	$(shell pkg-config xmlrpc_client --cflags 2> /dev/null || xmlrpc-c-config client --cflags)
CFLAGS+=	$(shell pkg-config xmlrpc --cflags 2> /dev/null)
CFLAGS+=	$(shell pkg-config xmlrpc_util --cflags 2> /dev/null)
ifeq ($(with_amr_tests),yes)
CFLAGS+=	-DWITH_AMR_TESTS
endif
CFLAGS+=	$(shell mysql_config --cflags)
else
CFLAGS+=	-DWITHOUT_CODECLIB
endif

LDLIBS=		-lm
LDLIBS+=	$(shell pkg-config --libs glib-2.0)
LDLIBS+=	$(shell pkg-config --libs gthread-2.0)
LDLIBS+=	$(shell pkg-config --libs libcrypto)
LDLIBS+=	$(shell pkg-config --libs openssl)
LDLIBS+=	$(shell pkg-config --libs libpcre)
ifeq ($(with_transcoding),yes)
LDLIBS+=	$(shell pkg-config --libs libavcodec)
LDLIBS+=	$(shell pkg-config --libs libavformat)
LDLIBS+=	$(shell pkg-config --libs libavutil)
LDLIBS+=	$(shell pkg-config --libs libswresample)
LDLIBS+=	$(shell pkg-config --libs libavfilter)
LDLIBS+=	$(shell pkg-config --libs spandsp)
LDLIBS+=	$(shell pkg-config --libs zlib)
LDLIBS+=	$(shell pkg-config --libs json-glib-1.0)
LDLIBS+=	-lpcap
LDLIBS+=	$(shell pkg-config --libs libevent_pthreads)
LDLIBS+=	$(shell pkg-config xmlrpc_client --libs 2> /dev/null || xmlrpc-c-config client --libs)
LDLIBS+=	$(shell pkg-config xmlrpc --libs 2> /dev/null)
LDLIBS+=	$(shell pkg-config xmlrpc_util --libs 2> /dev/null)
LDLIBS+=	-lhiredis
LDLIBS+=	$(shell mysql_config --libs)
endif

SRCS=		test-bitstr.c aes-crypt.c aead-aes-crypt.c test-const_str_hash.strhash.c
LIBSRCS=	loglib.c auxlib.c str.c rtplib.c
DAEMONSRCS=	crypto.c ssrc.c aux.c rtp.c
HASHSRCS=

ifeq ($(with_transcoding),yes)
SRCS+=		test-transcode.c test-dtmf-detect.c test-payload-tracker.c test-resample.c
SRCS+=		spandsp_recv_fax_pcm.c spandsp_recv_fax_t38.c spandsp_send_fax_pcm.c \
		spandsp_send_fax_t38.c
ifeq ($(with_amr_tests),yes)
SRCS+=		test-amr-decode.c test-amr-encode.c
endif
LIBSRCS+=	codeclib.c resample.c socket.c streambuf.c dtmflib.c
DAEMONSRCS+=	codec.c call.c ice.c kernel.c media_socket.c stun.c bencode.c poller.c \
		dtls.c recording.c statistics.c rtcp.c redis.c iptables.c graphite.c \
		cookie_cache.c udp_listener.c homer.c load.c cdr.c dtmf.c timerthread.c \
		media_player.c jitter_buffer.c t38.c tcp_listener.c
HASHSRCS+=	call_interfaces.c control_ng.c sdp.c
endif

OBJS=		$(SRCS:.c=.o) $(LIBSRCS:.c=.o) $(DAEMONSRCS:.c=.o) $(HASHSRCS:.c=.strhash.o)

COMMONOBJS=	str.o auxlib.o rtplib.o loglib.o

include ../lib/common.Makefile

.PHONY:		all-tests unit-tests daemon-tests all-daemon-tests \
	daemon-tests-main daemon-tests-jb daemon-tests-reorder daemon-tests-dtx daemon-tests-dtx-cn

TESTS=		test-bitstr aes-crypt aead-aes-crypt test-const_str_hash.strhash
ifeq ($(with_transcoding),yes)
TESTS+=		test-transcode test-dtmf-detect test-payload-tracker test-resample
ifeq ($(with_amr_tests),yes)
TESTS+=		test-amr-decode test-amr-encode
endif
endif

ADD_CLEAN=	tests-preload.so $(TESTS)

ifeq ($(with_transcoding),yes)
all-tests:	unit-tests daemon-tests
else
all-tests:	unit-tests
endif
	true # override linking recipe from common.Makefile

unit-tests:	$(TESTS)
	for x in $(TESTS); do echo testing: $$x; G_DEBUG=fatal-warnings ./$$x || exit 1; done

daemon-tests:	tests-preload.so
	$(MAKE) -C ../daemon
	$(MAKE) all-daemon-tests

all-daemon-tests: daemon-tests-main daemon-tests-jb daemon-tests-reorder daemon-tests-dtx daemon-tests-dtx-cn

daemon-tests-main:
	rm -rf fake-$@-sockets
	mkdir fake-$@-sockets
	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
		   perl -I../perl auto-daemon-tests.pl
	test "$$(ls fake-$@-sockets)" = ""
	rmdir fake-$@-sockets

daemon-tests-jb:
	rm -rf fake-$@-sockets
	mkdir fake-$@-sockets
	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
		   perl -I../perl auto-daemon-tests-jb.pl
	test "$$(ls fake-$@-sockets)" = ""
	rmdir fake-$@-sockets

daemon-tests-reorder:
	rm -rf fake-$@-sockets
	mkdir fake-$@-sockets
	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
		   perl -I../perl auto-daemon-tests-reorder.pl
	test "$$(ls fake-$@-sockets)" = ""
	rmdir fake-$@-sockets

daemon-tests-dtx:
	rm -rf fake-$@-sockets
	mkdir fake-$@-sockets
	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
		   perl -I../perl auto-daemon-tests-dtx.pl
	test "$$(ls fake-$@-sockets)" = ""
	rmdir fake-$@-sockets

daemon-tests-dtx-cn:
	rm -rf fake-$@-sockets
	mkdir fake-$@-sockets
	LD_PRELOAD=../t/tests-preload.so RTPE_BIN=../daemon/rtpengine TEST_SOCKET_PATH=./fake-$@-sockets \
		   perl -I../perl auto-daemon-tests-dtx-cn.pl
	test "$$(ls fake-$@-sockets)" = ""
	rmdir fake-$@-sockets

test-bitstr:	test-bitstr.o

spandsp_send_fax_pcm:	spandsp_send_fax_pcm.o

spandsp_recv_fax_pcm:	spandsp_recv_fax_pcm.o

spandsp_send_fax_t38:	spandsp_send_fax_t38.o

spandsp_recv_fax_t38:	spandsp_recv_fax_t38.o

spandsp_raw_fax_tests: spandsp_send_fax_pcm spandsp_recv_fax_pcm spandsp_send_fax_t38 spandsp_recv_fax_t38

test-amr-decode: test-amr-decode-test.o $(COMMONOBJS) codeclib.o resample.o dtmflib.o

test-amr-encode: test-amr-encode-test.o $(COMMONOBJS) codeclib.o resample.o dtmflib.o

test-dtmf-detect: test-dtmf-detect.o

aes-crypt:	aes-crypt.o $(COMMONOBJS) crypto.o

aead-aes-crypt:	aead-aes-crypt.o $(COMMONOBJS) crypto.o

test-transcode:	test-transcode.o $(COMMONOBJS) codeclib.o resample.o codec.o ssrc.o call.o ice.o aux.o \
	kernel.o media_socket.o stun.o bencode.o socket.o poller.o dtls.o recording.o statistics.o \
	rtcp.o redis.o iptables.o graphite.o call_interfaces.strhash.o sdp.strhash.o rtp.o crypto.o \
	control_ng.strhash.o \
	streambuf.o cookie_cache.o udp_listener.o homer.o load.o cdr.o dtmf.o timerthread.o \
	media_player.o jitter_buffer.o dtmflib.o t38.o tcp_listener.o

test-resample:	test-resample.o $(COMMONOBJS) codeclib.o resample.o dtmflib.o

test-payload-tracker: test-payload-tracker.o $(COMMONOBJS) ssrc.o aux.o auxlib.o rtp.o crypto.o codeclib.o \
	resample.o dtmflib.o

test-kernel-module: test-kernel-module.o $(COMMONOBJS) kernel.o

test-const_str_hash.strhash: test-const_str_hash.strhash.o $(COMMONOBJS)

PRELOAD_CFLAGS += -D_GNU_SOURCE -std=c99
PRELOAD_LIBS += -ldl

tests-preload.so:	tests-preload.c
	$(CC) $(PRELOAD_CFLAGS) -o $@ -shared -fPIC $< $(LDFLAGS) $(PRELOAD_LIBS)

spandsp_send_fax_pcm.c:	spandsp_logging.h
spandsp_send_fax_t38.c:	spandsp_logging.h
spandsp_recv_fax_t38.c:	spandsp_logging.h
spandsp_recv_fax_pcm.c:	spandsp_logging.h

=== debian/changelog ===
ngcp-rtpengine (9.5.1.3+0~mr9.5.1.3) unstable; urgency=medium

  [ Richard Fuchs ]
  * [93efd95] TT#14008 use appropriate allocation for a=rtcp-fb
  * [11063f8] TT#14008 handle possible NULL return from get_ssrc

 -- Sipwise Jenkins Builder <jenkins@sipwise.com>  Mon, 16 Aug 2021 14:36:22 +0200

ngcp-rtpengine (9.5.1.2+0~mr9.5.1.2) unstable; urgency=medium

  [ Richard Fuchs ]
  * [51a1219] TT#14008 delay learning of endpoint address after re-invite
  * [ea51c89] TT#14008 fix 64-bit division on 32-bit archs
  * [2ba4303] TT#14008 move avpkt alloc to encoder_new
  * [4d63f31] TT#121752 restore SSRC output per call in NG stats output
  * [0b52290] TT#121752 fix compiler warning
  * [a8bac49] TT#14008 ignore "received from" address when ICE is in use

 -- Sipwise Jenkins Builder <jenkins@sipwise.com>  Wed, 04 Aug 2021 15:33:46 +0200

ngcp-rtpengine (9.5.1.1+0~mr9.5.1.1) unstable; urgency=medium

  [ Richard Fuchs ]
  * [dca017f] TT#14800 update last_packet during signalling events
  * [b7facf4] TT#14008 reset SRTP index on endpoint change
  * [6dfdcc8] TT#14008 update for patched RH kernel
  * [9025660] TT#14008 skip duplicate comparison of basic codec params
  * [152e85b] TT#14008 fix transcoding logic
  * [6b5edc1] TT#14008 tests for GH #1289
  * [022190a] TT#121752 associate SSRC hash to monologue instead of entire call
  * [2becfd3] TT#14008 update tests after f2d7372f5a
  * [8b8b7fb] TT#14008 fix handling of large WS payloads
  * [505f20d] TT#14008 fix possible null pointer reference
  * [9cf09f6] TT#91151 fix erroneous variable re-use
  * [10b3b5a] TT#91151 fix transcoding unit test case
  * [492d5a0] TT#14008 fix minimum XR packet size check
  * [c1e0aa9] TT#121752 fix RTCP RR SSRC substitution when transcoding

  [ Nathanaël Semhoun ]
  * [53991a0] Fix G729 packet duration

 -- Sipwise Jenkins Builder <jenkins@sipwise.com>  Tue, 06 Jul 2021 14:38:00 +0200

ngcp-rtpengine (9.5.1.0+0~mr9.5.1.0) unstable; urgency=medium

  [ Guillem Jover ]
  * [8d7e4c7] TT#111150 Use test -z instead of a prefixed x
  * [89d1a77] TT#111150 Fix memory leak in test
  * [07695d2] TT#111150 Use modern <stdint.h> uint<bits>_t types
  * [2b4c4d0] TT#111150 When testing the daemon keep the stdout and stderr on failures
  * [27b2c2c] TT#111150 Fix unaligned access for AES GCM IV initialization
  * [87e8346] TT#111150 Use volatile in cast
  * [c09b379] TT#111150 Add an alternative implementation for taint_func
  * [adbd071] TT#111150 Do not use old-style declarations
  * [6fc7938] TT#111150 Use {} instead of ; to mark an empty body
  * [d3390ba] TT#111150 Enable -Wextra minus some of its warnings producing much noise

  [ Richard Fuchs ]
  * [6cc1e99] TT#14008 fix possible segfault when out of ports
  * [a2e05bd] TT#120402 always update output SSRC mapping
  * [ec42f83] TT#14008 allow usage with just HTTP/WS
  * [9d4b870] TT#14008 fix seq_file usage
  * [a9fdc21] TT#14008 amend kernel test script
  * [a8d5076] TT#119502 correctly restore calls from both Redis instances
  * [a2af257] TT#98901 fix DTX TS reset detection
  * [311069b] TT#14008 match SSRC printing in kernel with daemon
  * [aca786b] TT#99621 fix RTCP generation after it has been stopped once
  * [80099bd] TT#111150 fix mem leak in codec tracker
  * [87e5efc] TT#111150 fix mem leaks in test-transcode
  * [dbf79cb] TT#14008 allow re-invites for calls when load limit is hit
  * [61a852f] TT#14008 fix debug logging bug
  * [d5d0a3a] TT#111150 convert str.len to size_t
  * [e70d203] TT#108551 fix AEAD kernel encryption of small packets
  * [292ba2e] TT#111150 convert refcounting functions to macros
  * [6527fb5] TT#111150 fix an SSRC reference leak
  * [231fc0d] TT#111150 refactor log limiter to avoid GStringChunk
  * [df5f810] TT#14008 fix base64 encoding issues with older glib in t/
  * [983a703] TT#111150 remove stray compiler warning
  * [2057d0a] TT#14008 rate limit log line about missing output context
  * [92e3959] TT#111150 fix wrong allocation size being used
  * [b285665] TT#111150 use ssize_t for signed return type
  * [2dee580] TT#111150 remove useless comparisons
  * [dcad209] TT#111150 use intermediate variable for ftell()
  * [951f4d6] TT#111150 remove dead code
  * [addaa6a] TT#111150 add missing include
  * [1205f22] TT#111150 reformat struct initialiser
  * [4d251d5] TT#111150 disable -Wmissing-field-initializers for gperf
  * [3778bae] TT#14008 use const char in str_init_dup
  * [be30d2c] TT#111150 free cn_payload string if present
  * [24079de] TT#14008 add explicit type to STR*INIT macros
  * [faee34f] TT#14008 fix rand_hex_string usage
  * [ab8b25c] TT#14008 conditionally disable spandsp build test
  * [4c9b543] TT#122401 actually shut down DTX when out of time
  * [3062184] TT#14008 keep track of selected Redis DB
  * [1ec517c] TT#14008 restore foreign calls from the appropriate DB
  * [cc9fb06] TT#14008 fix possible segfault
  * [a009f76] TT#14008 support media echo and blackhole
  * [0e2bddb] TT#14008 add `pierce-NAT` flag
  * [586a802] TT#111150 fix initialisers in test-transcode
  * [1755ccf] TT#14008 use temporary variable to avoid stray compiler warning
  * [830abd6] TT#14008 add tests for media echo
  * [b1409e5] TT#122401 correct ptime handling for negative values
  * [7c3982e] TT#122401 rename "lost packet" functions to DTX
  * [da06ed2] TT#122401 add ptime to DTX trigger
  * [5d5098e] TT#122401 keep track of decoder's output format
  * [1198852] TT#122401 add generic silence DTX generator
  * [dc38a0e] TT#122401 support multiple DTX method per codec
  * [7e24a7e] TT#122401 add CN DTX method
  * [ec68dfe] TT#122401 add configurable CN method
  * [64670ff] TT#122401 add option to bypass AMR SID
  * [4f6af37] TT#122401 add early DTX logging context
  * [d4fbec3] TT#122401 return ptime from decoded packets for DTX
  * [4cbd676] TT#122401 add DTX tests
  * [9b296db] TT#122401 fix timing issues with fluctuating ptime
  * [ddfce1f] TT#111150 add unit test for resampler


=== debian/control ===
Source: ngcp-rtpengine
Section: net
Priority: optional
Maintainer: Sipwise Development Team <support@sipwise.com>
Homepage: https://www.sipwise.com/
Standards-Version: 3.9.8
Build-Depends:
 debhelper-compat (= 12),
 default-libmysqlclient-dev,
 gperf,
 libavcodec-dev (>= 6:10),
 libavfilter-dev (>= 6:10),
 libavformat-dev (>= 6:10),
 libavutil-dev (>= 6:10),
 libbcg729-dev <!pkg.ngcp-rtpengine.nobcg729>,
 libbencode-perl,
 libcrypt-openssl-rsa-perl,
 libcrypt-rijndael-perl,
 libcurl4-openssl-dev | libcurl4-gnutls-dev,
 libdigest-crc-perl,
 libdigest-hmac-perl,
 libevent-dev (>= 2.0),
 libglib2.0-dev (>= 2.30),
 libhiredis-dev,
 libio-multiplex-perl,
 libio-socket-inet6-perl,
 libio-socket-ip-perl,
 libiptc-dev,
 libjson-glib-dev,
 libnet-interface-perl,
 libpcap0.8-dev,
 libpcre3-dev,
 libsocket6-perl,
 libspandsp-dev,
 libssl-dev (>= 1.0.1),
 libswresample-dev (>= 6:10),
 libsystemd-dev,
 libwebsockets-dev,
 libxmlrpc-core-c3-dev (>= 1.16.07),
 libxtables-dev (>= 1.4) | iptables-dev (>= 1.4),
 markdown,
 zlib1g-dev,

Package: ngcp-rtpengine-daemon
Architecture: any
Recommends:
 ngcp-rtpengine-recording-daemon,
 ngcp-rtpengine-utils,
Suggests:
 ngcp-system-tools,
Depends:
 lsb-base (>= 3.0-6),
 ${misc:Depends},
 ${shlibs:Depends},
Description: proxy for RTP and media streams used in NGCP, userspace part
 This daemon handles the first stages of proxying media streams and talks to
 the kernel part of the proxy for eventual high-performance packet forwarding.

Package: ngcp-rtpengine-recording-daemon
Architecture: any
Build-Profiles: <!pkg.ngcp-rtpengine.no-transcoding>
Recommends:
 ngcp-rtpengine-utils,
Suggests:
 ngcp-system-tools,
Depends:
 lsb-base (>= 3.0-6),
 nfs-common,
 ${misc:Depends},
 ${shlibs:Depends},
Description: recording daemon for RTP and media streams
 This daemon handles the call recording (media intercept) component of rtpengine.

Package: ngcp-rtpengine-iptables
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: IPtables extension module for the kernel-space NGCP media proxy
 Provides the IPtables extension needed to configure the mediaproxy rule.

Package: ngcp-rtpengine
Architecture: all
Depends:
 ngcp-rtpengine-daemon (>= ${source:Version}),
 ngcp-rtpengine-iptables (>= ${source:Version}),
 ngcp-rtpengine-kernel-dkms (>= ${source:Version}),
 ngcp-rtpengine-recording-daemon (>= ${source:Version}),
 ngcp-rtpengine-utils (>= ${source:Version}),
 ${misc:Depends},
Description: NGCP RTP/media proxy - meta package
 This is a meta package for easy installation of all four parts of the NGCP
 media proxy. It will install the user-space daemon, the kernel-space IPtables
 module, the IPtables extension module and utility scripts.

Package: ngcp-rtpengine-kernel-source
Architecture: all
Section: kernel
Depends:
 debhelper-compat (= 12),
 module-assistant,
 ${misc:Depends},
Description: IPtables kernel module for the NGCP media proxy - source
 Provides the kernel-space part of the NGCP media proxy for high-
 performance packet forwarding.
 This package contains the source to be built with module-assistant or
 kernel-package.

Package: ngcp-rtpengine-kernel-dkms
Architecture: all
Section: kernel
Suggests:
 ngcp-system-tools,
Depends:
 dkms (>= 1.95),
 lsb-release,
 ${misc:Depends},
Description: IPtables kernel module for the NGCP media proxy - DKMS
 Provides the kernel-space part of the NGCP media proxy for high-
 performance packet forwarding.
 This package contains the source to be built with dkms.

Package: ngcp-rtpengine-utils
Architecture: all
Depends:
 libbencode-perl,
 libconfig-tiny-perl,
 libcrypt-rijndael-perl,
 libdigest-hmac-perl,
 libio-socket-inet6-perl,
 libio-socket-ip-perl,
 libsocket6-perl,
 netcat-openbsd | netcat,
 ${misc:Depends},
 ${perl:Depends},
Description: scripts and Perl modules for NGCP rtpengine
 This package contains scripts and Perl modules for NGCP rtpengine

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

# Uncomment this to turn on verbose mode.
# export DH_VERBOSE=1

include /usr/share/dpkg/pkg-info.mk

## kernel package specific stuff
# Name of the source package
psource:=ngcp-rtpengine-kernel-source
# Name of the dkms package
pdkms:=ngcp-rtpengine-kernel-dkms
# short upstream name, used for module source directory
sname:=ngcp-rtpengine
# Source version
sversion:=$(DEB_VERSION_UPSTREAM)

PACKAGE=ngcp-rtpengine-kernel
## end of kernel package specific stuff

XTABLES_DIR:=$(shell pkg-config xtables --variable=xtlibdir || echo /lib/xtables)

ifneq (,$(filter $(DEB_BUILD_PROFILES),pkg.ngcp-rtpengine.no-transcoding))
export with_transcoding = no
endif

%:
	dh $@

override_dh_auto_install-indep:
	# Create the directories to install the source into
	dh_installdirs -p$(psource)  usr/src/modules/$(sname)/debian
	dh_installdirs -p$(pdkms)    usr/src/$(sname)-$(sversion)

	# Copy only the driver source to the proper locations
	cd kernel-module && cp Makefile *.c *.h ../debian/$(psource)/usr/src/modules/$(sname)
	cd kernel-module && cp Makefile *.c *.h ../debian/$(pdkms)/usr/src/$(sname)-$(sversion)

	# Copy the needed debian/ pieces to the proper location
	cp debian/*.modules.in* debian/$(psource)/usr/src/modules/$(sname)/debian
	cp debian/control debian/changelog debian/copyright \
		debian/$(psource)/usr/src/modules/$(sname)/debian/
	install -m 0755 debian/rules.modules debian/$(psource)/usr/src/modules/$(sname)/debian/rules
	cd debian/$(psource)/usr/src && tar c modules | bzip2 -9 > $(sname).tar.bz2 && rm -rf modules

	# Prepare dkms.conf from the dkms.conf.in template
	sed "s/__VERSION__/$(sversion)/g" debian/dkms.conf.in > debian/$(pdkms)/usr/src/$(sname)-$(sversion)/dkms.conf

	# markdown README
	markdown README.md | gzip -9 > debian/README.html.gz
	gzip -9 < README.md > debian/README.md.gz

	dh_auto_install

override_dh_install:
	dh_install
	dh_installdirs -pngcp-rtpengine-iptables $(XTABLES_DIR)
	install -m 0644 iptables-extension/libxt_RTPENGINE.so debian/ngcp-rtpengine-iptables/$(XTABLES_DIR)

.PHONY: override_dh_strip
override_dh_strip:
	dh_strip --dbgsym-migration='ngcp-rtpengine-dbg (<= 6.0.0.0+0~mr6.0.0.0)'

override_dh_dwz:
	# Disable, as dwz cannot cope with some of the plugins generated.

override_dh_installsystemd:
	dh_installsystemd
	dh_installsystemd -pngcp-rtpengine-recording-daemon --name=ngcp-rtpengine-recording-nfs-mount
